# Start a "ipcluster" for this script to use:
# $ ipcluster local

import subprocess
import numpy
from time import time

from IPython.kernel import client

mec = client.MultiEngineClient()
init_code = """
import numpy
"""
mec.execute(init_code)


num_cpus = len(mec.get_ids())

x = int(numpy.ceil(1000.0/num_cpus)*num_cpus)
y = 200

# Create a dictionary with objects to
# send once to worker

a = numpy.random.uniform(size=(x,y))
b = numpy.random.uniform(size=(y,x))

# send second matrix to workers
mec['b'] = b

print "starting."
t1 = time()
ans1 = numpy.dot(a,b)
print "1 CPU:", time()-t1


# This beautfial code is VERY slow
# note we work with 1000x200 here
# not 4000x200 as with mpi and multiprocessing examples
t1 = time()
mec.scatter('a', a)
mec.execute("c = numpy.dot(a,b)")
ans2 = mec.gather('c')

print "%d CPUs:" % num_cpus, time()-t1

print "Same?:", numpy.alltrue(abs(ans1-ans2)<1e-11)
